<?php
// $Id: supercron.php,v 1.1.2.1 2009/06/05 06:37:11 63reasons Exp $

/**
 * @file
 * Handles incoming requests to fire off regularly-scheduled tasks (cron jobs).
 */

ignore_user_abort(TRUE);

include_once './includes/bootstrap.inc';
drupal_bootstrap(DRUPAL_BOOTSTRAP_FULL);

// IP authorization check
if(variable_get(SUPERCRON_FIREWALL_ENABLED_VARIABLE, FALSE)) {
    $mode = variable_get(SUPERCRON_FIREWALL_MODE_VARIABLE, 'only');
    $ip = ip_address();
    $result = db_query('SELECT * FROM {supercron_ips}');
    if ($mode == 'only') {
        $authorized = FALSE;
        while ($dbip = db_fetch_object($result)) {
            if ($ip == $dbip->ip) {
                $authorized = TRUE;
                break;
            }
        }
    }
    else if ($mode == 'except') {
        $authorized = TRUE;
        while ($dbip = db_fetch_object($result)) {
            if ($ip == $dbip->ip) {
                $authorized = FALSE;
                break;
            }
        }
    }
    if (!$authorized)
        die("IP '$ip' not authorized!");
}

//Throttle check
if(module_exists('throttle') && variable_get(SUPERCRON_THROTTLE_SUPPORT_VARIABLE, FALSE) && throttle_status())
    die('Site is under heavy load; cron tasks postponed.');

$safety = $_GET['safety'];
if($safety) {
  if ($safety != variable_get(SUPERCRON_SAFETY_VARIABLE)) die('Safety Mismatch');
  $module = $_GET['module'];
  if (!module_exists($module)) die('Non-Existant Module');
  supercron_invoke_one($module);
}
else supercron_module_invoke_all_cron();
